zoukankan      html  css  js  c++  java
  • 【17.69%】【codeforces 659F】Polycarp and Hay

    time limit per test4 seconds
    memory limit per test512 megabytes
    inputstandard input
    outputstandard output
    The farmer Polycarp has a warehouse with hay, which can be represented as an n × m rectangular table, where n is the number of rows, and m is the number of columns in the table. Each cell of the table contains a haystack. The height in meters of the hay located in the i-th row and the j-th column is equal to an integer ai, j and coincides with the number of cubic meters of hay in the haystack, because all cells have the size of the base 1 × 1. Polycarp has decided to tidy up in the warehouse by removing an arbitrary integer amount of cubic meters of hay from the top of each stack. You can take different amounts of hay from different haystacks. Besides, it is allowed not to touch a stack at all, or, on the contrary, to remove it completely. If a stack is completely removed, the corresponding cell becomes empty and no longer contains the stack.

    Polycarp wants the following requirements to hold after the reorganization:

    the total amount of hay remaining in the warehouse must be equal to k,
    the heights of all stacks (i.e., cells containing a non-zero amount of hay) should be the same,
    the height of at least one stack must remain the same as it was,
    for the stability of the remaining structure all the stacks should form one connected region.
    The two stacks are considered adjacent if they share a side in the table. The area is called connected if from any of the stack in the area you can get to any other stack in this area, moving only to adjacent stacks. In this case two adjacent stacks necessarily belong to the same area.

    Help Polycarp complete this challenging task or inform that it is impossible.

    Input
    The first line of the input contains three integers n, m (1 ≤ n, m ≤ 1000) and k (1 ≤ k ≤ 1018) — the number of rows and columns of the rectangular table where heaps of hay are lain and the required total number cubic meters of hay after the reorganization.

    Then n lines follow, each containing m positive integers ai, j (1 ≤ ai, j ≤ 109), where ai, j is equal to the number of cubic meters of hay making the hay stack on the i-th row and j-th column of the table.

    Output
    In the first line print “YES” (without quotes), if Polycarpus can perform the reorganisation and “NO” (without quotes) otherwise. If the answer is “YES” (without quotes), then in next n lines print m numbers — the heights of the remaining hay stacks. All the remaining non-zero values should be equal, represent a connected area and at least one of these values shouldn’t be altered.

    If there are multiple answers, print any of them.

    Examples
    input
    2 3 35
    10 4 9
    9 9 7
    output
    YES
    7 0 7
    7 7 7
    input
    4 4 50
    5 9 1 1
    5 1 1 5
    5 1 5 5
    5 5 7 1
    output
    YES
    5 5 0 0
    5 0 0 5
    5 0 5 5
    5 5 5 0
    input
    2 4 12
    1 1 3 1
    1 6 2 4
    output
    NO
    Note
    In the first sample non-zero values make up a connected area, their values do not exceed the initial heights of hay stacks. All the non-zero values equal 7, and their number is 5, so the total volume of the remaining hay equals the required value k = 7·5 = 35. At that the stack that is on the second line and third row remained unaltered.

    【题解】

    有一个数字不能变?
    给的n*m矩阵中又全都是大于0的数字;
    则最后的结果肯定是全都是那个不变的数字;
    则枚举那个不变的数字是啥;
    那个数字首先肯定要能整除k;
    则k%a[i][j]==0
    (1e17的因子也才300多个);
    然后从那个点开始bfs(floodfill);遇到小于ai,j的则不行->只能减少数字;
    然后遇到大于的则标记为访问过;
    之后如果找到了答案就把那个访问过的数字直接改成枚举得到的aij;
    其他数字改为0;
    有两个剪枝:
    1.k/a[i][j]>n*m直接剪掉;
    2.在bfs的时候如果发现和bfs的起始点aij数字一样的则标记下次不要再从那个点开始了;->一个数的因子是有限的。这样就防止了它整张图都是k的因子;

    #include <cstdio>
    #include <cmath>
    #include <set>
    #include <map>
    #include <iostream>
    #include <algorithm>
    #include <cstring>
    #include <queue>
    #include <vector>
    #include <stack>
    #include <string>
    #define LL long long
    
    using namespace std;
    
    const int MAXN = 1010;
    const int dx[5] = {0,1,-1,0,0};
    const int dy[5] = {0,0,0,-1,1};
    
    int n,m;
    LL k,need;
    int a[MAXN][MAXN];
    bool can[MAXN][MAXN],vis[MAXN][MAXN];
    queue < pair<int,int> >dl;
    
    void input_LL(LL &r)
    {
        r = 0;
        char t = getchar();
        while (!isdigit(t)) t = getchar();
        LL sign = 1;
        if (t == '-')sign = -1;
        while (!isdigit(t)) t = getchar();
        while (isdigit(t)) r = r * 10 + t - '0', t = getchar();
        r = r*sign;
    }
    
    void input_int(int &r)
    {
        r = 0;
        char t = getchar();
        while (!isdigit(t)) t = getchar();
        int sign = 1;
        if (t == '-')sign = -1;
        while (!isdigit(t)) t = getchar();
        while (isdigit(t)) r = r * 10 + t - '0', t = getchar();
        r = r*sign;
    }
    
    bool bfs(int x,int y)
    {
        for (int i = 1;i <= n;i++)
            for (int j = 1;j <= m;j++)
                vis[i][j] = false;
        dl.push(make_pair(x,y));
        LL now = 1;
        vis[x][y] = true;
        if (now == need)
            return true;
        while (!dl.empty())
        {
            int x0 = dl.front().first,y0 = dl.front().second;
            dl.pop();
            for (int i = 1;i <= 4;i++)
            {
                int x1 = x0+dx[i],y1 = y0+dy[i];
                if (x1<=0 || x1>=n+1 || y1<=0 || y1>=m+1) continue;
                if (!vis[x1][y1])
                {
                    if (a[x1][y1]<a[x][y]) continue;
                    if (a[x1][y1] == a[x][y]) can[x1][y1] = false;
                    vis[x1][y1] = true;
                    now++;
                    if (now == need)
                        return true;
                    dl.push(make_pair(x1,y1));
                }
            }
        }
        return false;
    }
    
    int main()
    {
        //freopen("F:\rush.txt", "r", stdin);
        input_int(n);input_int(m);input_LL(k);
        for (int i = 1;i <= n;i++)
            for (int j = 1;j <= m;j++)
                input_int(a[i][j]),can[i][j] = true;
        for (int i = 1;i <= n;i++)
            for (int j = 1;j <= m;j++)
                if (can[i][j] && !(k%a[i][j]))
                    {
                        need = k/a[i][j];
                        if (need >n*m)
                            continue;
                        if (bfs(i,j))
                        {
                            puts("YES");
                            for (int ii = 1;ii <= n;ii++)
                            {
                                for (int jj = 1;jj <= m;jj++)
                                    if (vis[ii][jj])
                                        printf("%d%c",a[i][j],jj==m?'
    ':' ');
                                    else
                                        printf("0%c",jj==m?'
    ':' ');
                            }
                            return 0;
                        }
                    }
        puts("NO");
        return 0;
    }
    
  • 相关阅读:
    C#中的静态
    C#类的使用
    C#接口实现多态
    C#---->类和接口
    winform项目导入数据
    kms访问数据库的方式(该篇只是作为个人笔记,不具有任何公共参考意图)
    win7下安装docker toolbox
    JabRef:将bibtex格式的参考文献导入EndNote的转换软件
    RabbitMQ安装以及简单操作应用(针对Windows和C#)
    C# Task和异步方法
  • 原文地址:https://www.cnblogs.com/AWCXV/p/7632116.html
Copyright © 2011-2022 走看看